package edu.northwestern.cs.aqualab.cattle.logging;

public class Format {
    private static final long SECOND = 1000;
    private static final long MINUTE = SECOND * 60;
    private static final long HOUR = MINUTE * 60;
    private static final long DAY = HOUR * 24;


    /**
     * Convert a period, in milliseconds, to a short string that is easy to read
     * but probably not exactly equivalent.
     */
    public static String approximateFamiliarInterval(long millis) {
        if (millis > DAY) {
            return String.format("%.1f days", (double) millis / DAY);
        }

        if (millis > HOUR) {
            return String.format("%.1f hours", (double) millis / HOUR);
        }

        if (millis > MINUTE) {
            return String.format("%.1f minutes", (double) millis / MINUTE);
        }

        return String.format("%.1f seconds", (double) millis / SECOND);
    }

}
