package edu.northwestern.cs.aqualab.cattle.logging;

import java.io.PrintStream;



/**
 * Log to stderr. This is a fallback.
 */
public class StderrLogger implements Logger {
    public void error(String tag, String message, Object... args) {
        stderrLog(tag, "error", message, args);
    }


    public void warn(String tag, String message, Object... args) {
        stdoutLog(tag, "warn", message, args);
    }


    public void debug(String tag, String message, Object... args) {
        stdoutLog(tag, "debug", message, args);
    }


    private static void stdLog(PrintStream stream, String tag, String level, String message,
                               Object... args) {
        StringBuilder sb = new StringBuilder();
        sb.append(tag);
        sb.append(":");
        sb.append(level);
        sb.append(" ");
        sb.append(String.format(message, args));
        stream.println(sb.toString());
    }


    private static void stdoutLog(String tag, String level, String message, Object... args) {
        stdLog(System.out, tag, level, message, args);
    }


    private static void stderrLog(String tag, String level, String message, Object... args) {
        stdLog(System.err, tag, level, message, args);
    }
}
