/**
 * Dasu Project
 *
 * File:         Test.java
 * RCS:          $Id: Test.java,v 1.0 Oct 22, 2013 5:11:40 PM mas939 Exp $
 * Description:  Test class (see below)
 * Author:       Mario Sanchez
 *               Northwestern Systems Research Group
 *               Department of Computer Science
 *               Northwestern University
 * Created:      Oct 22, 2013 at 5:11:40 PM
 * Language:     Java
 * Package:      edu.northwestern.dasu.dynamic.coordination
 * Status:       Experimental (Do Not Distribute)
 *
 * (C) Copyright 2013, Northwestern University, all rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */
package edu.northwestern.dasu.dynamic.coordination;

import java.util.ArrayList;

import edu.northwestern.cs.aqualab.cattle.jsonsimple.JSONObject;
import edu.northwestern.dasu.measurement.tasks.ProbeTask;
import edu.northwestern.dasu.measurement.tasks.ProbeTask.ProbeSubTask;
import edu.northwestern.dasu.measurement.types.ProbeType;
import edu.northwestern.dasu.measurement.types.SourceType;

/**
 * @author Mario Sanchez &lt;msanchez@eecs.northwestern.edu&gt;
 *
 * The Test class ...
 */
public class Test {

	public static void printArr(Integer[] arr) {
		
    	for ( int i=0; i<arr.length; i++) {
    		System.out.print(arr[i] + " ");
    	}
    	System.out.println();
	}
	
    public static void main(String[] args) {
    	    	
    	Integer[] arr = new Integer[]{8,4,3,2,6};
    	printArr(arr);

//    	for (int i=0; i < arr.length; i++) {    		
//    		for (int j=0; j<arr.length-1; j++) {        		    			
//    			if ( arr[j] > arr[j+1]) {    				
//    				int val = arr[j];
//    				arr[j] = arr[j+1];
//    				arr[j+1] = val;
//    			}
//    		}
//    		printArr(arr);
//    	}

    	for (int i=1; i < arr.length; i++) {
    		
    		int j=i-1;
    		int val = arr[i];
    		printArr(arr);
    		while (j>=0 && arr[j] > val ) {    			
    			arr[j+1] = arr[j];
    			j--;
    		}    		    		
    		arr[j+1] =val;    		
    	}
    	
    	
    	printArr(arr);
    	System.exit(0);
    	
            //String words[] = { "a", "apple", "argument", "aptitude", "ball", "bats", "bat", "batse"};
            //Trie trie = new Trie(Arrays.asList(words));
            //System.out.println(trie.getWordsAlongPrefix("bats"));
            //System.out.println(trie.getWord("bat"));
            
//            String[] subnets = {"0.0.0.0/0", "172.58.128.0/19", "172.58.128.0/17", "172.58.160.0/19"};
//            String[] ips = {"172.58.218.80", "172.58.165.90", "172.58.124.36", "172.58.169.18", "172.58.155.112", "172.59.12.142"};
//            
//            SubnetManager sm = new SubnetManager();
//            for ( String s : subnets ) {
//            	sm.addSubnet(s);
//            }
//            
//            for ( String ip : ips) {
//            	System.out.println(ip + " " + sm.getLongestPrefixMatch(ip));
//            }
    	
    	
		String hostPort = "127.0.0.1:2181";
		String taskId = "7980322";
		//String myUUID = "5a94acea-42aa-4781-a00b-0d1873d1d9b0";
		String myUUID = "1a94acea-42aa-4781-a00b-0d1873d1d9b1";
		String myIp = "10.0.0.1";
		String myCc = "DO";
		String myAsn = "15169";
		
		ArrayList <String> listOfIPs = new ArrayList<String>();
		listOfIPs.add("127.110.23.9");
		listOfIPs.add("127.0.22.15");
		listOfIPs.add("192.168.0.3");
		listOfIPs.add("192.168.0.1");
		
		CuratorConnectionNonPersistent client;
		try {
			
			//client = new CuratorConnectionNonPersistent(hostPort, taskId, myUUID, myIp, myCc, myAsn);			
			
			JSONObject distributedCoordinatorParams = new JSONObject();
			distributedCoordinatorParams.put("serverList", hostPort);
			distributedCoordinatorParams.put("taskId", "7980322");
			ZooKeeperDistributedCoordinator zk = new ZooKeeperDistributedCoordinator(SourceType.AME, "dasuCoordination_", distributedCoordinatorParams);
			zk.start();
			
			while ( zk.isAlive() ) {
				Thread.sleep(5*1000);
				
				for ( ProbeType pt : new ProbeType[]{ProbeType.PING, ProbeType.TRACEROUTE, ProbeType.HTTP}) {
					ProbeTask probeTask = new ProbeTask(Integer.parseInt(taskId), listOfIPs, pt);
					for ( ProbeSubTask pst : probeTask.getSubTasks()) {
						zk.schedulable(pst);
					}
				
				}
				
				System.out.println("isFailed: " + zk.isFailed());
				
			}
				
			/*
			HashMap<String, List<String>> probes = new HashMap();
			probes.put("PING", ListOfIPs);
			probes.put("HTTP", ListOfIPs);
			probes.put("DNS", ListOfIPs);
			
			//client.reportProbedIPs(ListOfIPs, "PING");//ProbeType can be Tr, Http or Ping
			client.reportProbedIPs(probes);//ProbeType can be Tr, Http or Ping
			
			System.out.println(client.PullUpdatedLease());
			System.out.println(client.PullUpdatedLease());
			*/

		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	
    }

}