package edu.northwestern.dasu.dynamic.drools;

import java.util.HashMap;

import edu.northwestern.cs.aqualab.cattle.jsonsimple.JSONObject;
import edu.northwestern.dasu.drools.FactProbeResult;
import edu.northwestern.dasu.measurement.types.ProbeType;
import edu.northwestern.dasu.util.Util;

public class FactHttpExtendedProbeResult extends FactProbeResult{
	
	private static final long serialVersionUID = 1L;
	
	public String url;
	public Long time;		

	public Boolean failed;
	public String error;
	
	public String ip;
	public String hostname;
	public String obj;	
	public Integer status;
	public HashMap<String, String> headers;
	public Long totalTime;
	
	// adding these together gives the total time, start to finish
	public Long initTime;
	public Long connectTime;
	public Long sendHeadTime;
	public Long recvHeadTime;
	public Long firstByteTime;
	public Long restOfBytesTime;
	
	public Integer headBytes;
	public Integer objBytes;
	
	
	public FactHttpExtendedProbeResult(String url) {
		super(ProbeType.valueOf("HTTP2"));
		this.url = url;
		this.time = Util.currentGMTTime();
	}
		
	public void setTotalTime(long time) {
		this.totalTime = time;
	}
	
	public void setConnect(long time) {
		this.connectTime = time;
	}
	
	public void setSendHead(long time) {
		this.sendHeadTime = time;
	}
	
	public void setTime(long time) {
		this.initTime = time;
	}
	
	public void setFailed(Boolean failed) {
		this.failed = failed;
	}
	
	public void setError(String error) {
		this.error = error;
	}
	
	public void setHeaders(HashMap<String, String> headers) {
		this.headers = headers;
	}
	
	public void setStatus(Integer status) {
		this.status = status;
	}
	
	public void setHeadBytes(Integer headBytes) {
		this.headBytes = headBytes;
	}
	
	public void setObjBytes(Integer objBytes) {
		this.objBytes = objBytes;
	}
	
	public void setRestOfBytes(Long restOfBytes) {
		this.restOfBytesTime = restOfBytes;
	}
	
	public void setFirstByte(Long firstByte) {
		this.firstByteTime = firstByte;
	}
	
	public void setRecvHead(Long recvHead) {
		this.recvHeadTime = recvHead;
	}
	
	public void setIp(String ip) {
		this.ip = ip;
	}
	
	public void setHost(String hostname) {
		this.hostname = hostname;
	}
	
	public void setObj( String obj) {
		this.obj = obj;
	}
	
	public JSONObject toJSON() {

		JSONObject json = super.toJSON();
		json.remove("url");
		json.remove("taskId");
		json.remove("time");
		
		return json;
	}
	
	
	

}
