package edu.northwestern.dasu.dynamic.drools;

import edu.northwestern.dasu.drools.FactProbeResult;
import edu.northwestern.dasu.measurement.types.ProbeType;

public class FactYouTubeProbeResult extends FactProbeResult{
	
	private static final long serialVersionUID = 1L;
	public String url = null;
	public int taskId = -1;
	public long timestamp = -1;
	public String browserType = "";
	public String results = "";
	public String interfaceName = "";
	public String interfaceType = "";
	public Boolean interrupted = false;

	public FactYouTubeProbeResult(String url) {
		super(ProbeType.valueOf("YOUTUBE"));
		this.url = url;
	}
	
	public FactYouTubeProbeResult(String url, int taskId) {
		super(ProbeType.valueOf("YOUTUBE"));
		this.url = url;
		this.taskId = taskId;
		
	}

	public FactYouTubeProbeResult(String url, int taskId,
			long timestamp, String interfaceName, String interfaceType, String browserType, String results) {
		super(ProbeType.valueOf("YOUTUBE"));
		this.url = url;
		this.taskId = taskId;
		this.timestamp = timestamp;
		this.interfaceName = interfaceName;
		this.interfaceType = interfaceType;
		this.browserType = browserType;
		this.results = results;
	}
	
	public String getUrl() {
		return url;
	}

	public int getTaskId() {
		return taskId;
	}

	public long getTimestamp() {
		return timestamp;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	public void setTaskId(int taskId) {
		this.taskId = taskId;
	}

	public void setTimestamp(long timestamp) {
		this.timestamp = timestamp;
	}

	public String getBrowserType() {
		return browserType;
	}

	public void setBrowserType(String browserType) {
		this.browserType = browserType;
	}

	public String getInterfaceName() {
		return interfaceName;
	}

	public void setInterfaceName(String interfaceName) {
		this.interfaceName = interfaceName;
	}

	public String getInterfaceType() {
		return interfaceType;
	}

	public void setInterfaceType(String interfaceType) {
		this.interfaceType = interfaceType;
	}

	public String getResults() {
		return results;
	}

	public void setResults(String results) {
		this.results = results;
	}
	
	public boolean isInterrupted() {
		return this.interrupted;
	}
	
	public void setInterrupted(Boolean interrupt) {
		this.interrupted = interrupt;
	}

}
