/**
 * Dasu Project
 *
 * File:         DasuSubTask.java
 * RCS:          $Id: DasuSubTask.java,v 1.0 Feb 9, 2013 7:25:12 PM mas939 Exp $
 * Description:  DasuSubTask class (see below)
 * Author:       Mario Sanchez
 *               Northwestern Systems Research Group
 *               Department of Computer Science
 *               Northwestern University
 * Created:      Feb 9, 2013 at 7:25:12 PM
 * Language:     Java
 * Package:      edu.northwestern.dasu.measurement.tasks
 * Status:       Experimental (Do Not Distribute)
 *
 * (C) Copyright 2013, Northwestern University, all rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */
package edu.northwestern.dasu.measurement.tasks;

import edu.northwestern.dasu.measurement.types.EventType;
import edu.northwestern.dasu.measurement.types.SourceType;


public interface DasuSubTask<E extends EventType> {

	public long getId();
	
	public E getType();
	
	public Integer getPriority();
	
	public SourceType getSourceType();
	
	public void recordExecutionPathTimestamp(String name, Object time);
	
}
