/**
 * Dasu Project
 *
 * File:         DasuTask.java
 * RCS:          $Id: DasuTask.java,v 1.0 Feb 9, 2013 7:09:18 PM mas939 Exp $
 * Description:  DasuTask class (see below)
 * Author:       Mario Sanchez
 *               Northwestern Systems Research Group
 *               Department of Computer Science
 *               Northwestern University
 * Created:      Feb 9, 2013 at 7:09:18 PM
 * Language:     Java
 * Package:      edu.northwestern.dasu.measurement.tasks
 * Status:       Experimental (Do Not Distribute)
 *
 * (C) Copyright 2013, Northwestern University, all rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */
package edu.northwestern.dasu.measurement.tasks;

import java.util.Collection;

import edu.northwestern.cs.aqualab.cattle.jsonsimple.JSONObject;
import edu.northwestern.dasu.measurement.types.EventType;
import edu.northwestern.dasu.measurement.types.SourceType;

/**
 * @author Mario Sanchez &lt;msanchez@eecs.northwestern.edu&gt;
 *
 * The DasuTask class ...
 */
public interface DasuTask<T> {
	
	public EventType getType();
	
	public Integer getPriority();
	
	public Collection<T> getSubTaskList();

	public SourceType getSourceType();
	
	public void setPriority(int prior);
	
	public JSONObject toJSON();
	
}
