package edu.northwestern.dasu.sandbox.applet;

import java.rmi.*;
import java.rmi.server.*;

import edu.northwestern.dasu.drools.FactTemplate;
import edu.northwestern.dasu.measurement.types.SourceType;
import edu.northwestern.dasu.sandbox.mainSandboxedProcess;

public class NotifyRemoteTimerTask extends UnicastRemoteObject implements NotifyInterface {

	private static final long serialVersionUID = 1L;
	
	private Object[] params;
    private RmiAMCoordinatorInterface remoteAMC;
    private SourceType engineId;
    private java.util.logging.Logger LOGGER = java.util.logging.Logger.getLogger("edu.northwestern.dasu");

    public NotifyRemoteTimerTask(Object[] params, RmiAMCoordinatorInterface rt, SourceType engine) throws RemoteException {
    	this.remoteAMC = rt;
    	this.params = params;
    	this.engineId = engine;
    }
    
    public SourceType getEngineId() {
    	return engineId;
    }
    
    public void doneIt() {
        try {        	        	        	
        	FactTemplate fact = remoteAMC.getResult(this);
        	if ( mainSandboxedProcess.getEngine(engineId) != null)
        		mainSandboxedProcess.getEngine(engineId).addFact(fact);
        }
        catch(Exception e){
        	e.printStackTrace();            
        }
    }

	public Object getParameter() {
		return params;
	}
	
	public String getNotifyClassName() {
		return this.getClass().getSimpleName(); 
	}
    
}