/**
 * Dasu Project
 *
 * File:         Event.java
 * RCS:          $Id: Event.java,v 1.0 Jul 29, 2011 5:16:56 PM mas939 Exp $
 * Description:  Event class (see below)
 * Author:       Mario Sanchez
 *               Northwestern Systems Research Group
 *               Department of Computer Science
 *               Northwestern University
 * Created:      Jul 29, 2011 at 5:16:56 PM
 * Language:     Java
 * Package:      edu.northwestern.dasu.simulator
 * Status:       Experimental (Do Not Distribute)
 *
 * (C) Copyright 2011, Northwestern University, all rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */
package edu.northwestern.dasu.simulator;

import java.lang.reflect.Field;
import java.util.Date;
import java.util.HashMap;

/**
 * @author Mario Sanchez &lt;msanchez@eecs.northwestern.edu&gt;
 *
 * The Event class ...
 */
public class SimulatedEvent implements Comparable<SimulatedEvent>{
	
	public Long timeStamp = -1l;
	public String type;
	public Class className;
	public HashMap<String, String> fields;
	
	public SimulatedEvent(String type, Class c) {
		fields = new HashMap<String, String>();
		this.type = type;
		this.className = c;
	}

	public int compareTo(SimulatedEvent obj) {
		
		return timeStamp.compareTo(obj.timeStamp);
		
	}
	
    @Override
    public String toString() {
    	
    	String ret = "Event: < " + new Date(timeStamp) + " => ";
    	try {
        	
    		for ( Field f : this.getClass().getFields()) {
    		
    			if ( f.get(this) != null)
    				ret = ret.concat(f.getName() + ": " + f.get(this).toString() + " ");
    		}
    		
    	} catch (Exception e) {
    		e.printStackTrace();
    	}
    	
    	ret = ret.concat(">\n");
    	return ret;
    }
	

}
