/**
 * Dasu Project
 *
 * File:         Answer.java
 * RCS:          $Id: Answer.java,v 1.0 Jun 19, 2013 5:27:14 PM mas939 Exp $
 * Description:  Answer class (see below)
 * Author:       Mario Sanchez
 *               Northwestern Systems Research Group
 *               Department of Computer Science
 *               Northwestern University
 * Created:      Jun 19, 2013 at 5:27:14 PM
 * Language:     Java
 * Package:      edu.northwestern.dasu.ui
 * Status:       Experimental (Do Not Distribute)
 *
 * (C) Copyright 2013, Northwestern University, all rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */
package edu.northwestern.dasu.ui;



/**
 * @author Mario Sanchez &lt;msanchez@eecs.northwestern.edu&gt;
 *
 * The Answer class ...
 */

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.eclipse.jetty.server.Handler;
import org.eclipse.jetty.server.Request;
import org.eclipse.jetty.server.Server;
import org.eclipse.jetty.server.handler.AbstractHandler;
import org.eclipse.jetty.server.handler.HandlerList;
import org.eclipse.jetty.server.handler.ResourceHandler;

import edu.northwestern.cs.aqualab.cattle.jsonsimple.JSONObject;

public class Answer extends AbstractHandler {
	  
  public void handle(String target, Request baseRequest, HttpServletRequest request,
      HttpServletResponse response) throws IOException, ServletException {
	
	if ( target.contains("favicon.ico"))
		return;
	
	System.out.println(target);
	System.out.println(baseRequest);
	System.out.println(request);
	System.out.println(response);
	System.out.println(request.getParameter("id"));
	System.out.println(request.getParameterMap());
	
    String id = request.getParameter("id");
    response.setContentType("application/json;charset=utf-8");
    //response.setContentType("text/xml");
    response.setHeader("Cache-Control", "no-cache");
    //response.setContentLength(19 + id.length());
    response.setStatus(HttpServletResponse.SC_OK);
    JSONObject json = new JSONObject();
    json.put("id", id);
    System.out.println(json.toJSONString());    
    response.setContentLength(json.toJSONString().length());
    //response.getWriter().write("<message>"+id+"</message>");
    response.getWriter().write(json.toJSONString());
    response.flushBuffer();
    baseRequest.setHandled(true);
  }

  public static void main(String[] args) throws Exception {
    Server server = new Server(8081);

    ResourceHandler resource_handler = new ResourceHandler();
    resource_handler.setDirectoriesListed(true);
    resource_handler.setWelcomeFiles(new String[] { "index.html" });
    resource_handler.setResourceBase("./src/edu/northwestern/dasu/ui/");

    HandlerList handlers = new HandlerList();
    handlers.setHandlers(new Handler[] { resource_handler, new Answer() });

    server.setHandler(handlers);
    server.start();
    server.join();
  }
}